BUFMAX=2048
MAXPLUGINDATA=40

FLOWSPEC	struct
	TokenRate	dd	?
	TokenBucketSize	dd	?
	PeakBandwidth	dd	?
	Latency		dd	?
	DelayVariation	dd	?
	ServiceType	dd	?
	MaxSduSize	dd	?
	MinimumPolicedSize dd	?
FLOWSPEC	ends

QOS	struct
	sending		FLOWSPEC	<>
	receiving	FLOWSPEC	<>
	provider	dd		?,?
QOS	ends

OVERLAPPEDPLUS struct
	ovr		OVERLAPPED <>
	opcode		dd	?
	hSocket		dd	?
	hMem		dd	?
	retries		dd	?
	bfsize2		dd	?
	buffer2		dd	?
	written		dd	?
	bfidx2		dd	?
OVERLAPPEDPLUS ends

cmdstruc	STRUCT
	cmdptr		dd	?
	cmdproc		dd	?
	floodflag	dd	?
	flcnt1		dw	?
	flcnt2		dw	?
	counter		dd	?
	cmdflag		dd	?
	cmdparam1	dd	?
	cmdparam2	dd	?
	_lasttick	dd	?
	_flcnt1		dw	?
	_flcnt2		dw	?
cmdstruc	ENDS


cmdstr_	STRUCT
	lasttick	dd	?
	flcnt1		dw	?
	flcnt2		dw	?
	flag1		db	?
cmdstr_	ENDS


usrstruc	STRUCT
	hMem1		dd	?
	hSocket		dd	?
	hThread		dd	?
	hThread1	dd	?
	locked		db	?
	robotmsg	dd	?
	waiting		db	?
	modifier	dw	?
	rights		db	?,?,?,?,?,?,?,?
	access		dd	?,?,?,?
	accflag		db	?
	ipptr		dd	?
	profileid	dw	?
	userid		dd	?
	loggedin	db	?
	_ip		dd	?
	_port		dd	?
	_lastmode	dd	?
	_num_x		dd	?
	modeptr		dd	?
	conntime	dd	?
	proftime	dd	?
	profptr		dd	?
	portidx		db	?
	histptr		dd	?
	sessionId	dd	?
	repcount	db	?
	rep_all		dd	?
	rep_asc		dd	?
	pmspamsum	dd	?	;message checksum
	pmspamlen	dd	?	;message length
	pmspamtick	dd	?	;tick count
	pmspamusers	dd	?	;users different
	pmspamusr	dd	?	;last usrstruc
	pm_is_spam	dd	?	;spam detected
	lastpmtcount	dd	?
	lastpmcount	dw	?
	_discard	db	?
	req_name	db	41 dup(?)
	_name		db	41 dup(?)
	descr		db	200 dup(?)
	tag		db	53 dup(?)
	hubs		db	?,?,?,?,?,?
	hubssave	dd	?
	sharesave	dd	?,?
	connection	db	21 dup(?)
	mail		db	30 dup(?)
	share		db	40 dup(?)
	modetime	dd	?
	_nummode	dd	?
	whoistime	dd	?
	_numwhois	dd	?
	_lastkicktime	dd	?
	_lasthelptime	dd	?,?
	_lastnicktime	dd	?,?
	_lasthubltime	dd	?,?
	_numkicks	dd	?
	cmdflood	cmdstr_ <>
		cs_key			cmdstr_ <>
		cs_supports		cmdstr_ <>
		cs_version		cmdstr_ <>
		cs_validatenick		cmdstr_ <>
		cs_mypass		cmdstr_ <>
		cs_getnicklist		cmdstr_ <>
		cs_myinfo		cmdstr_ <>
		cs_getinfo		cmdstr_ <>
		cs_botinfo		cmdstr_ <>
		cs_connecttome		cmdstr_ <>
		cs_revconnecttome	cmdstr_ <>
		cs_multiconnecttome	cmdstr_ <>
		cs_search		cmdstr_ <>
		cs_sr			cmdstr_ <>
		cs_multisearch		cmdstr_ <>
		cs_userip		cmdstr_ <>
		cs_kick			cmdstr_ <>
		cs_opforcemove		cmdstr_ <>
		cs_to			cmdstr_ <>
		cs_mainchat_message	cmdstr_ <>
		cs_unknown_command	cmdstr_ <>
		cs_unknown_data		cmdstr_ <>
		cs_help_about		cmdstr_ <>
		cs_language		cmdstr_ <>
		cs_hublist		cmdstr_ <>
		cs_motd_topic		cmdstr_ <>
		cs_whois_who_seen	cmdstr_ <>
		cs_hex_asc		cmdstr_ <>
		cs_op_deop		cmdstr_ <>
		cs_say_write_mc_me	cmdstr_ <>
		cs_mode			cmdstr_ <>
		cs_autoreg_setprofile	cmdstr_ <>
		cs_kick_ban_unban	cmdstr_ <>
		cs_other_cmds		cmdstr_ <>
		cs_minus		cmdstr_ <>
		cs_plugins		cmdstr_ 16 dup(<>)
	cmdtmp		dd	?
	myinfwait	dw	?
	myinfwait1	db	?
	lpPlugin	dd	?
	plugin		dd	?
	lpFunc		dd	?
	lpPM		dd	?
	outDisable	db	?	;1=disabled
					;2=disconnect on UnloadPlugin
					;4=is bot
	lptr	dd	?	;pointer to language table
	buffer_in	db	BUFMAX+10 dup(?)
	plugdata	db	MAXPLUGINDATA dup(?)
	buffer_tmp	db	50 dup(?)
	fdset		db	10 dup(?)
	_qos		QOS	<>
	cmdtype		dd	?
	cmdcount	dd	?
	cmdtime		dd	?
	s__bufno	dd	?
	s__idx		dd	?
	s__bufpm	dd	?
	s__idxpm	dd	?
	s__retry	dd	?
	s__lastsid	dd	?
	s__logintime	dd	?
;	s__loginblock	dd	?
	s__lastsendtime	dd	?
	s__leveltime	dd	?
	ovr		OVERLAPPEDPLUS <>
	ovr_send	OVERLAPPEDPLUS <>
	last_op		db	?
usrstruc	ENDS
